"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Types
var error_1 = require("./error");
// Validation
var validate = __importStar(require("./validation"));
function streamie(handler, config) {
    var queue = {
        // TODO make these linked lists
        input: [],
        output: {
            success: [],
        },
    };
    var settings = {
        backpressureAt: validate.backpressureAt(config),
        concurrency: config.concurrency || 1,
        batchSize: config.batchSize || 1,
        maxBatchWait: config.maxBatchWait || Infinity,
        isFilter: config.isFilter === true,
        haltOnError: config.haltOnError !== false,
        flatten: config.flatten === true,
        propagateErrors: config.propagateErrors !== false,
    };
    var state = {
        count: {
            started: 0,
            handling: 0,
        },
        lastHandledAt: null,
        // Backpressure slowly builds backwards. If you imagine that a downstream streamie has input backpressure,
        // this streamie will stop pushing to it. This means that eventually this streamie will have output backpressure,
        // and we will stop handling items. This means that eventually this streamie will have input backpressure, and
        // upstream streamies will stop pushing to it... and so on.
        backpressure: {
            // When the input queue is too long, upstream streamies should stop pushing items into the queue.
            get input() {
                return queue.input.length >= settings.backpressureAt.input;
            },
            // When the output queue is too long, this streamie should stop handling items.
            get output() {
                return (queue.output.success.length + state.count.handling) >= settings.backpressureAt.output;
            },
        },
        get isDrained() {
            return state.shouldDrain && (queue.input.length === 0) && (state.count.handling === 0) && (queue.output.success.length === 0);
        },
        shouldDrain: false,
        isPaused: false,
        isHalted: false,
        hasHandledOnDrained: false,
    };
    var outputStreamies = new Set();
    var inputStreamies = new Set();
    var eventHandlers = {
        onBackpressureRelease: new Set(),
        onDrained: new Set(),
        onDraining: new Set(),
        onError: new Set(),
        onHalted: new Set(),
    };
    var maxBatchWaitTimeout = null;
    // Internal functions
    function processInput() {
        return __awaiter(this, void 0, void 0, function () {
            var timeSinceLastHandled, startedWithBackpressure, itemsToHandle, handlerInput, index, handlerOutput_1, err_1, queueError;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (state.isPaused || state.isHalted || state.isDrained)
                            return [2 /*return*/];
                        if (queue.input.length === 0)
                            return [2 /*return*/];
                        if (state.backpressure.output)
                            return [2 /*return*/];
                        timeSinceLastHandled = state.lastHandledAt && Date.now() - state.lastHandledAt;
                        // This top level condition establishes a normal condition under which we would not handle
                        // the items, as there aren't enough to justify a batch. However, we will handle them
                        // given the exceptions below
                        if (queue.input.length < settings.batchSize) {
                            if (
                            // If the queue is meant to be drained, even if the input queue is not a full batch,
                            // we will still handle it.
                            (!state.shouldDrain) &&
                                // If we have waited too long since the last handled batch, we will handle the items
                                !(timeSinceLastHandled && (timeSinceLastHandled > settings.maxBatchWait))) {
                                // At this point, we're already not going to handle the items the process, but if
                                // there is a maxBatchWait configured, we will ensure that there is a timeout in place
                                // to call processInput after the maxBatchWait time has elapsed. This is because the
                                // qualification for maxBatchWait time could elapse and be qualified for a process, but
                                // no attempt to process would necessarily be invoked at that time.
                                if (settings.maxBatchWait && (settings.maxBatchWait !== Infinity)) {
                                    if (maxBatchWaitTimeout)
                                        clearTimeout(maxBatchWaitTimeout);
                                    maxBatchWaitTimeout = setTimeout(function () {
                                        requestProcessInput();
                                    }, settings.maxBatchWait - (timeSinceLastHandled || 0));
                                }
                                return [2 /*return*/];
                            }
                        }
                        if (state.count.handling >= settings.concurrency)
                            return [2 /*return*/];
                        startedWithBackpressure = state.backpressure.input;
                        state.lastHandledAt = Date.now();
                        state.count.handling++;
                        itemsToHandle = queue.input.splice(0, settings.batchSize);
                        handlerInput = (settings.batchSize === 1 ? itemsToHandle[0] : itemsToHandle);
                        // Since we're in a valid state to process items and we're not yet at concurrency limit,
                        // we begin another attempt to process items.
                        requestProcessInput();
                        if (startedWithBackpressure && !state.backpressure.input) {
                            eventHandlers.onBackpressureRelease.forEach(function (eventHandler) {
                                eventHandler();
                            });
                        }
                        index = state.count.started++;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, handler(handlerInput, {
                                self: self,
                                push: self.push,
                                index: index,
                            })];
                    case 2:
                        handlerOutput_1 = _a.sent();
                        // Only wrapped in an IIFE to allow for early returns.
                        (function () {
                            // If the handler is a filter, the return value is a boolean, and if the return value is false, we
                            // do not push to the output queue. If the output is truthy, we pass the input through to
                            // the output queue.
                            if (settings.isFilter) {
                                if (!handlerOutput_1)
                                    return; // Handler returned false, so we do not push anything to the output queue.
                                var filterOutput = handlerInput; // Handler returned true, so we push the input to the output queue.
                                var successQueue_1 = queue.output.success;
                                if (!settings.flatten) {
                                    return successQueue_1.push({ input: handlerInput, output: filterOutput });
                                }
                                if (!Array.isArray(handlerInput))
                                    throw new Error('Cannot flatten input that is not an array.');
                                // At this point we are flattening either an array of inputs that are arrayed due to batching, or
                                // the input is itself an array. We don't care which, we just want to flatten it. Adding additional
                                // conditionals to check batchSize just to improve the typing from any[] is not worth actually adding
                                // actual complexity to the runtime code.
                                return successQueue_1.push.apply(successQueue_1, filterOutput.map(function (input) { return ({ input: input, output: input }); }));
                            }
                            var successQueue = queue.output.success;
                            if (settings.flatten) {
                                if (!Array.isArray(handlerOutput_1))
                                    throw new Error('Cannot flatten output that is not an array.');
                                successQueue.push.apply(successQueue, handlerOutput_1.map(function (output) { return ({ input: handlerInput, output: output }); }));
                            }
                            else
                                successQueue.push({ input: handlerInput, output: handlerOutput_1 });
                        })();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        queueError = new error_1.StreamieQueueError(
                        // @ts-ignore
                        "Encountered an error while processing input: ".concat((err_1 === null || err_1 === void 0 ? void 0 : err_1.message) || ''), err_1, {
                            input: handlerInput,
                            index: index,
                            timestamp: Date.now(),
                        });
                        handleOnError(queueError);
                        return [3 /*break*/, 4];
                    case 4:
                        state.count.handling--;
                        requestProcessOutput();
                        requestProcessInput();
                        return [2 /*return*/];
                }
            });
        });
    }
    function processOutput() {
        if (state.isPaused || state.isHalted || state.isDrained)
            return;
        if (queue.output.success.length === 0)
            return;
        // TODO should allow different strategies, but for now we will say that if any consumer
        // is backpressured, no other outputStreamies will be pushed to, as this could allow a queue
        // to grow indefinitely.
        if (Array.from(outputStreamies).some(function (consumer) { return consumer.state.backpressure.input; }))
            return;
        var success = queue.output.success.shift();
        outputStreamies.forEach(function (consumer) {
            consumer.push(success.output);
        });
        requestProcessOutput();
        requestProcessInput();
    }
    function requestProcessInput() {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Allow this to be more complicated logic in future.
                    return [4 /*yield*/, processInput()];
                    case 1:
                        // Allow this to be more complicated logic in future.
                        _a.sent();
                        if (state.isDrained)
                            handleOnDrained();
                        return [2 /*return*/];
                }
            });
        });
    }
    function requestProcessOutput() {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Allow this to be more complicated logic in future.
                    return [4 /*yield*/, processOutput()];
                    case 1:
                        // Allow this to be more complicated logic in future.
                        _a.sent();
                        if (state.isDrained)
                            handleOnDrained();
                        return [2 /*return*/];
                }
            });
        });
    }
    function handleOnError(queueError) {
        // If this stream is configured to haltOnError, then its own promise
        // will have registered on onError listener to reject the promise, which
        // will be invoked here.
        eventHandlers.onError.forEach(function (eventHandler) {
            eventHandler(queueError);
        });
        if (settings.propagateErrors) {
            outputStreamies.forEach(function (consumer) {
                consumer._pushQueueError(queueError);
            });
        }
        // Important to do this at the end so errors can be handled before children
        // are removed from halting
        if (settings.haltOnError)
            setHalted();
    }
    function handleOnDrained() {
        if (!state.isDrained || state.hasHandledOnDrained)
            return;
        state.hasHandledOnDrained = true;
        eventHandlers.onDrained.forEach(function (eventHandler) {
            eventHandler();
        });
    }
    function setHalted() {
        if (state.isHalted)
            return;
        state.isHalted = true;
        eventHandlers.onHalted.forEach(function (eventHandler) {
            eventHandler();
        });
    }
    // Public functions
    function push() {
        var _a;
        var items = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            items[_i] = arguments[_i];
        }
        if (state.isHalted)
            throw new Error('Cannot push to a halted streamie.');
        if (state.shouldDrain)
            throw new Error("Cannot push to a ".concat(state.isDrained ? 'drained' : 'draining', " streamie."));
        (_a = queue.input).push.apply(_a, items);
        requestProcessInput();
    }
    function map(handler, config) {
        var nextStreamie = streamie(handler, config);
        registerOutput(nextStreamie);
        return nextStreamie;
    }
    function filter(handler, config) {
        var nextStreamie = map(
        // @ts-ignore
        handler, __assign(__assign({}, config), { isFilter: true }));
        return nextStreamie;
    }
    // TODO add reduce, flatMap, etc.
    function pause(shouldPause) {
        state.isPaused = shouldPause !== null && shouldPause !== void 0 ? shouldPause : !state.isPaused;
        if (!state.isPaused)
            requestProcessInput();
    }
    function drain() {
        if (state.shouldDrain)
            return;
        state.shouldDrain = true;
        eventHandlers.onDraining.forEach(function (eventHandler) { return eventHandler(); });
        // Move to next tick to allow for a final push to output queue. Items can still be pushed
        // to the output queue while draining, but if the streamie is considered drained immediately
        // upon draining, then the onDrained event will be fired before the final push to the output.
        setTimeout(function () { return requestProcessInput(); });
    }
    // This registers an input streamie, so that this streamie can be triggered to drain
    // in the event that all of its input streamies are drained.
    function registerInput(inputStreamie) {
        if (state.isDrained)
            throw new Error('Cannot register an input on a drained streamie.');
        if (inputStreamie.state.isDrained)
            throw new Error('Cannot register a drained streamie as an input.');
        if (state.isHalted)
            throw new Error('Cannot register an input on a halted streamie.');
        if (inputStreamie.state.isHalted)
            throw new Error('Cannot register a halted streamie as an input.');
        if (inputStreamies.has(inputStreamie))
            return;
        inputStreamies.add(inputStreamie);
        inputStreamie.onDrained(drainIfAllInputsDrained);
        inputStreamie.onHalted(function () {
            inputStreamies.delete(inputStreamie);
            drainIfAllInputsDrained();
        });
        inputStreamie.registerOutput(self);
        function drainIfAllInputsDrained() {
            if (Array.from(inputStreamies).every(function (inputStreamie) { return inputStreamie.state.isDrained; })) {
                drain();
            }
        }
    }
    function registerOutput(outputStreamie) {
        if (state.isDrained)
            throw new Error('Cannot register an output on a drained streamie.');
        if (outputStreamie.state.isDrained)
            throw new Error('Cannot register a drained streamie as an output.');
        if (state.isHalted)
            throw new Error('Cannot register an output on a halted streamie.');
        if (outputStreamie.state.isHalted)
            throw new Error('Cannot register a halted streamie as an output.');
        if (outputStreamies.has(outputStreamie))
            return;
        outputStreamies.add(outputStreamie);
        outputStreamie.onBackpressureRelease(function () { return requestProcessOutput(); });
        outputStreamie.onHalted(function () { return outputStreamies.delete(outputStreamie); });
        // This would be a strange scenario, but it's not disallowed. If a streamie
        // with inputs is set to drain, we simply remove it as an output.
        outputStreamie.onDraining(function () { return outputStreamies.delete(outputStreamie); });
        outputStreamie.registerInput(self);
    }
    function onBackpressureRelease(eventHandler) {
        eventHandlers.onBackpressureRelease.add(eventHandler);
    }
    function onDrained(eventHandler) {
        if (state.isDrained)
            return eventHandler();
        eventHandlers.onDrained.add(eventHandler);
    }
    function onDraining(eventHandler) {
        if (state.shouldDrain)
            return eventHandler();
        eventHandlers.onDraining.add(eventHandler);
    }
    function onError(eventHandler) {
        eventHandlers.onError.add(eventHandler);
    }
    function onHalted(eventHandler) {
        if (state.isHalted)
            return eventHandler();
        eventHandlers.onHalted.add(eventHandler);
    }
    // Private functions
    // This is to allow upstream streamies to propagate errors. Should not be invoked for
    // another reason. We can't know the type generics because it could have been passed
    // from a parent of a parent, etc.
    function _pushQueueError(error) {
        // TODO maybe at some point we should distinguish between whether "shouldPropagateErrors"
        // means "should I pass my errors on" vs "should I allow other errors to be passed on to me"
        if (settings.propagateErrors)
            handleOnError(error);
    }
    var self = {
        push: push,
        map: map,
        filter: filter,
        pause: pause,
        drain: drain,
        registerInput: registerInput,
        registerOutput: registerOutput,
        state: {
            get backpressure() {
                return state.backpressure;
            },
            get count() {
                return {
                    started: state.count.started,
                    handling: state.count.handling,
                    queued: {
                        get input() { return queue.input.length; },
                        get output() { return queue.output.success.length; },
                    },
                };
            },
            get isPaused() {
                return state.isPaused;
            },
            get isDrained() {
                return state.isDrained;
            },
            get isHalted() {
                return state.isHalted;
            },
        },
        onBackpressureRelease: onBackpressureRelease,
        onDrained: onDrained,
        onDraining: onDraining,
        onError: onError,
        onHalted: onHalted,
        _pushQueueError: _pushQueueError,
        promise: new Promise(function (resolve, reject) {
            onDrained(function () { return resolve(null); });
            if (settings.haltOnError)
                onError(function (error) { return reject(error); });
        }),
    };
    if (config.seed !== undefined)
        setTimeout(function () { return self.push(config.seed); }, 0);
    return self;
}
exports.default = streamie;
